Index: pjproject/trunk/pjnath/build/wince-evc4/pjnath_wince.vcp
===================================================================
--- pjproject/trunk/pjnath/build/wince-evc4/pjnath_wince.vcp	(revision 1912)
+++ pjproject/trunk/pjnath/build/wince-evc4/pjnath_wince.vcp	(revision 1913)
@@ -6595,4 +8230,12 @@
 
 SOURCE=..\..\include\pjnath\stun_transaction.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\include\pjnath\turn_session.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\..\include\pjnath\turn_sock.h
 # End Source File
 # Begin Source File
Index: pjproject/trunk/pjnath/include/pjnath.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath.h	(revision 1912)
+++ pjproject/trunk/pjnath/include/pjnath.h	(revision 1913)
@@ -29,5 +29,5 @@
 #include <pjnath/stun_transaction.h>
 #include <pjnath/turn_session.h>
-#include <pjnath/turn_udp.h>
+#include <pjnath/turn_sock.h>
 #include <pjnath/types.h>
 
Index: pjproject/trunk/pjnath/include/pjnath/turn_session.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 1912)
+++ pjproject/trunk/pjnath/include/pjnath/turn_session.h	(revision 1913)
@@ -56,10 +56,27 @@
 
 
-/** TURN transport types */
+/** 
+ * TURN transport types, which will be used both to specify the connection 
+ * type for reaching TURN server and the type of allocation transport to be 
+ * requested to server (the REQUESTED-TRANSPORT attribute).
+ */
 typedef enum pj_turn_tp_type
 {
-    PJ_TURN_TP_UDP = 17,    /**< UDP.	*/
-    PJ_TURN_TP_TCP = 6,	    /**< TCP.	*/
-    PJ_TURN_TP_TLS = 256    /**< TLS.	*/
+    /**
+     * UDP transport, which value corresponds to IANA protocol number.
+     */
+    PJ_TURN_TP_UDP = 17,
+
+    /**
+     * TCP transport, which value corresponds to IANA protocol number.
+     */
+    PJ_TURN_TP_TCP = 6,
+
+    /**
+     * TLS transport. The TLS transport will only be used as the connection
+     * type to reach the server and never as the allocation transport type.
+     */
+    PJ_TURN_TP_TLS = 255
+
 } pj_turn_tp_type;
 
@@ -219,4 +236,16 @@
 } pj_turn_session_info;
 
+
+/**
+ * Create default pj_turn_alloc_param.
+ */
+PJ_DECL(void) pj_turn_alloc_param_default(pj_turn_alloc_param *prm);
+
+/**
+ * Duplicate pj_turn_alloc_param.
+ */
+PJ_DECL(void) pj_turn_alloc_param_copy(pj_pool_t *pool, 
+				       pj_turn_alloc_param *dst,
+				       const pj_turn_alloc_param *src);
 
 /**
@@ -240,5 +269,11 @@
 
 /**
- * Destroy TURN client session.
+ * Shutdown TURN client session.
+ */
+PJ_DECL(pj_status_t) pj_turn_session_shutdown(pj_turn_session *sess);
+
+
+/**
+ * Forcefully destroy the TURN session.
  */
 PJ_DECL(pj_status_t) pj_turn_session_destroy(pj_turn_session *sess);
Index: pjproject/trunk/pjnath/include/pjnath/turn_sock.h
===================================================================
--- pjproject/trunk/pjnath/include/pjnath/turn_sock.h	(revision 1913)
+++ pjproject/trunk/pjnath/include/pjnath/turn_sock.h	(revision 1913)
@@ -0,0 +1,142 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2007 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJNATH_turn_sock_H__
+#define __PJNATH_turn_sock_H__
+
+/**
+ * @file turn_sock.h
+ * @brief TURN relay using UDP client as transport protocol
+ */
+#include <pjnath/turn_session.h>
+
+
+PJ_BEGIN_DECL
+
+
+/* **************************************************************************/
+/**
+ * @defgroup PJNATH_TURN_UDP TURN TCP client
+ * @brief TURN relay using TCP client as transport protocol
+ * @ingroup PJNATH_STUN
+ * @{
+ */
+
+
+/** 
+ * Opaque declaration for TURN TCP client.
+ */
+typedef struct pj_turn_sock pj_turn_sock;
+
+
+typedef struct pj_turn_sock_cb
+{
+    /**
+     * Notification when incoming data has been received, either through
+     * Data indication or ChannelData message from the TURN server.
+     *
+     * This callback is mandatory.
+     */
+    void (*on_rx_data)(pj_turn_sock *turn_sock,
+		       const pj_uint8_t *pkt,
+		       unsigned pkt_len,
+		       const pj_sockaddr_t *peer_addr,
+		       unsigned addr_len);
+
+    /**
+     * Notification when TURN session state has changed. Application should
+     * implement this callback to know that the TURN session is no longer
+     * available.
+     */
+    void (*on_state)(pj_turn_sock *turn_sock, pj_turn_state_t old_state,
+		     pj_turn_state_t new_state);
+
+} pj_turn_sock_cb;
+
+
+/**
+ * Create.
+ */
+PJ_DECL(pj_status_t) pj_turn_sock_create(pj_stun_config *cfg,
+					 int af,
+					 pj_turn_tp_type conn_type,
+					 const pj_turn_sock_cb *cb,
+					 unsigned options,
+					 void *user_data,
+					 pj_turn_sock **p_turn_sock);
+
+/**
+ * Destroy.
+ */
+PJ_DECL(void) pj_turn_sock_destroy(pj_turn_sock *turn_sock);
+
+/**
+ * Set user data.
+ */
+PJ_DECL(pj_status_t) pj_turn_sock_set_user_data(pj_turn_sock *turn_sock,
+					       void *user_data);
+
+/**
+ * Get user data.
+ */
+PJ_DECL(void*) pj_turn_sock_get_user_data(pj_turn_sock *turn_sock);
+
+
+/**
+ * Get info.
+ */
+PJ_DECL(pj_status_t) pj_turn_sock_get_info(pj_turn_sock *turn_sock,
+					  pj_turn_session_info *info);
+
+/**
+ * Initialize.
+ */
+PJ_DECL(pj_status_t) pj_turn_sock_init(pj_turn_sock *turn_sock,
+				       const pj_str_t *domain,
+				       int default_port,
+				       pj_dns_resolver *resolver,
+				       const pj_stun_auth_cred *cred,
+				       const pj_turn_alloc_param *param);
+
+/**
+ * Send packet.
+ */ 
+PJ_DECL(pj_status_t) pj_turn_sock_sendto(pj_turn_sock *turn_sock,
+					const pj_uint8_t *pkt,
+					unsigned pkt_len,
+					const pj_sockaddr_t *addr,
+					unsigned addr_len);
+
+/**
+ * Bind a peer address to a channel number.
+ */
+PJ_DECL(pj_status_t) pj_turn_sock_bind_channel(pj_turn_sock *turn_sock,
+					      const pj_sockaddr_t *peer,
+					      unsigned addr_len);
+
+
+/**
+ * @}
+ */
+
+
+PJ_END_DECL
+
+
+#endif	/* __PJNATH_turn_sock_H__ */
+
Index: pjproject/trunk/pjnath/src/pjnath/ice_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 1912)
+++ pjproject/trunk/pjnath/src/pjnath/ice_session.c	(revision 1913)
@@ -114,4 +114,5 @@
 /* These are the callbacks registered to the STUN sessions */
 static pj_status_t on_stun_send_msg(pj_stun_session *sess,
+				    void *token,
 				    const void *pkt,
 				    pj_size_t pkt_size,
@@ -122,8 +123,10 @@
 				      unsigned pkt_len,
 				      const pj_stun_rx_data *rdata,
+				      void *token,
 				      const pj_sockaddr_t *src_addr,
 				      unsigned src_addr_len);
 static void on_stun_request_complete(pj_stun_session *stun_sess,
 				     pj_status_t status,
+				     void *token,
 				     pj_stun_tx_data *tdata,
 				     const pj_stun_msg *response,
@@ -134,4 +137,5 @@
 					 unsigned pkt_len,
 					 const pj_stun_msg *msg,
+					 void *token,
 					 const pj_sockaddr_t *src_addr,
 					 unsigned src_addr_len);
@@ -1393,5 +1397,4 @@
     rd->clist = clist;
     rd->ckid = check_id;
-    check->tdata->user_data = (void*) rd;
 
     /* Add PRIORITY */
@@ -1425,6 +1428,6 @@
 
     /* Initiate STUN transaction to send the request */
-    status = pj_stun_session_send_msg(comp->stun_sess, PJ_FALSE, 
-				      &rcand->addr, 
+    status = pj_stun_session_send_msg(comp->stun_sess, (void*)rd, PJ_FALSE, 
+				      PJ_TRUE, &rcand->addr, 
 				      sizeof(pj_sockaddr_in), check->tdata);
     if (status != PJ_SUCCESS) {
@@ -1645,4 +1648,5 @@
  */
 static pj_status_t on_stun_send_msg(pj_stun_session *sess,
+				    void *token,
 				    const void *pkt,
 				    pj_size_t pkt_size,
@@ -1652,4 +1656,7 @@
     stun_data *sd = (stun_data*) pj_stun_session_get_user_data(sess);
     pj_ice_sess *ice = sd->ice;
+
+    PJ_UNUSED_ARG(token);
+
     return (*ice->cb.on_tx_pkt)(ice, sd->comp_id, 
 				pkt, pkt_size, 
@@ -1661,4 +1668,5 @@
 static void on_stun_request_complete(pj_stun_session *stun_sess,
 				     pj_status_t status,
+				     void *token,
 				     pj_stun_tx_data *tdata,
 				     const pj_stun_msg *response,
@@ -1666,5 +1674,5 @@
 				     unsigned src_addr_len)
 {
-    struct req_data *rd = (struct req_data*) tdata->user_data;
+    struct req_data *rd = (struct req_data*) token;
     pj_ice_sess *ice;
     pj_ice_sess_check *check, *new_check;
@@ -1906,4 +1914,5 @@
 				      unsigned pkt_len,
 				      const pj_stun_rx_data *rdata,
+				      void *token,
 				      const pj_sockaddr_t *src_addr,
 				      unsigned src_addr_len)
@@ -1921,15 +1930,12 @@
     PJ_UNUSED_ARG(pkt);
     PJ_UNUSED_ARG(pkt_len);
+    PJ_UNUSED_ARG(token);
 
     /* Reject any requests except Binding request */
     if (msg->hdr.type != PJ_STUN_BINDING_REQUEST) {
-	status = pj_stun_session_create_res(sess, rdata, 
-					    PJ_STUN_SC_BAD_REQUEST,
-					    NULL, &tdata);
-	if (status != PJ_SUCCESS)
-	    return status;
-
-	return pj_stun_session_send_msg(sess, PJ_TRUE, 
-					src_addr, src_addr_len, tdata);
+	pj_stun_session_respond(sess, rdata, PJ_STUN_SC_BAD_REQUEST, 
+				NULL, NULL, PJ_TRUE, 
+				src_addr, src_addr_len);
+	return PJ_SUCCESS;
     }
 
@@ -1995,11 +2001,7 @@
 	} else {
 	    /* Generate 487 response */
-	    status = pj_stun_session_create_res(sess, rdata, 
-					        PJ_STUN_SC_ROLE_CONFLICT,
-						NULL, &tdata);
-	    if (status == PJ_SUCCESS) {
-		pj_stun_session_send_msg(sess, PJ_TRUE, 
-				         src_addr, src_addr_len, tdata);
-	    }
+	    pj_stun_session_respond(sess, rdata, PJ_STUN_SC_ROLE_CONFLICT, 
+				    NULL, NULL, PJ_TRUE, 
+				    src_addr, src_addr_len);
 	    pj_mutex_unlock(ice->mutex);
 	    return PJ_SUCCESS;
@@ -2011,11 +2013,7 @@
 	if (pj_cmp_timestamp(&ice->tie_breaker, &role_attr->value) < 0) {
 	    /* Generate 487 response */
-	    status = pj_stun_session_create_res(sess, rdata, 
-					        PJ_STUN_SC_ROLE_CONFLICT,
-						NULL, &tdata);
-	    if (status == PJ_SUCCESS) {
-		pj_stun_session_send_msg(sess, PJ_TRUE, 
-				         src_addr, src_addr_len, tdata);
-	    }
+	    pj_stun_session_respond(sess, rdata, PJ_STUN_SC_ROLE_CONFLICT, 
+				    NULL, NULL, PJ_TRUE, 
+				    src_addr, src_addr_len);
 	    pj_mutex_unlock(ice->mutex);
 	    return PJ_SUCCESS;
@@ -2041,5 +2039,5 @@
 					   PJ_TRUE, src_addr, src_addr_len);
 
-    status = pj_stun_session_send_msg(sess, PJ_TRUE, 
+    status = pj_stun_session_send_msg(sess, NULL, PJ_TRUE, PJ_TRUE,
 				      src_addr, src_addr_len, tdata);
 
@@ -2287,4 +2285,5 @@
 					 unsigned pkt_len,
 					 const pj_stun_msg *msg,
+					 void *token,
 					 const pj_sockaddr_t *src_addr,
 					 unsigned src_addr_len)
@@ -2294,4 +2293,5 @@
     PJ_UNUSED_ARG(pkt_len);
     PJ_UNUSED_ARG(msg);
+    PJ_UNUSED_ARG(token);
     PJ_UNUSED_ARG(src_addr);
     PJ_UNUSED_ARG(src_addr_len);
@@ -2368,5 +2368,5 @@
     if (stun_status == PJ_SUCCESS) {
 	status = pj_stun_session_on_rx_pkt(comp->stun_sess, pkt, pkt_size,
-					   PJ_STUN_IS_DATAGRAM,
+					   PJ_STUN_IS_DATAGRAM, NULL,
 					   NULL, src_addr, src_addr_len);
 	if (status != PJ_SUCCESS) {
Index: pjproject/trunk/pjnath/src/pjnath/ice_strans.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 1912)
+++ pjproject/trunk/pjnath/src/pjnath/ice_strans.c	(revision 1913)
@@ -61,4 +61,5 @@
 /* STUN session callback */
 static pj_status_t stun_on_send_msg(pj_stun_session *sess,
+				    void *token,
 				    const void *pkt,
 				    pj_size_t pkt_size,
@@ -67,4 +68,5 @@
 static void stun_on_request_complete(pj_stun_session *sess,
 				     pj_status_t status,
+				     void *token,
 				     pj_stun_tx_data *tdata,
 				     const pj_stun_msg *response,
@@ -491,5 +493,5 @@
 						   bytes_read, 
 						   PJ_STUN_IS_DATAGRAM, NULL,
-						   &comp->src_addr, 
+						   NULL, &comp->src_addr, 
 						   comp->src_addr_len);
 	    } else if (ice_st->ice) {
@@ -601,6 +603,4 @@
 	//tdata->user_data = NULL;
 
-	// We need this to support mapped address change
-	tdata->user_data = &comp->cand_list[j];
 	++comp->pending_cnt;
 
@@ -610,6 +610,6 @@
 		  pj_inet_ntoa(comp->local_addr.ipv4.sin_addr),
 		  pj_ntohs(comp->local_addr.ipv4.sin_port)));
-	status = pj_stun_session_send_msg(comp->stun_sess, PJ_FALSE, 
-					  &ice_st->stun_srv, 
+	status = pj_stun_session_send_msg(comp->stun_sess, &comp->cand_list[j],
+					  PJ_FALSE, PJ_TRUE, &ice_st->stun_srv,
 					  sizeof(pj_sockaddr_in), tdata);
 	if (status != PJ_SUCCESS) {
@@ -701,7 +701,6 @@
 	return status;
 
-    /* Attach alias instance to tdata */
+    /* Will be attached to tdata in send_msg() */
     cand = &comp->cand_list[comp->cand_cnt];
-    tdata->user_data = (void*)cand;
 
     /* Add pending count first, since stun_on_request_complete()
@@ -721,6 +720,6 @@
 
     /* Send STUN binding request */
-    status = pj_stun_session_send_msg(comp->stun_sess, PJ_FALSE, 
-				      &ice_st->stun_srv, 
+    status = pj_stun_session_send_msg(comp->stun_sess, (void*)cand, PJ_FALSE, 
+				      PJ_TRUE, &ice_st->stun_srv, 
 				      sizeof(pj_sockaddr_in), tdata);
     if (status != PJ_SUCCESS) {
@@ -1079,4 +1078,5 @@
  */
 static pj_status_t stun_on_send_msg(pj_stun_session *sess,
+				    void *token,
 				    const void *pkt,
 				    pj_size_t size,
@@ -1087,4 +1087,6 @@
     pj_ssize_t pkt_size;
     pj_status_t status;
+
+    PJ_UNUSED_ARG(token);
 
     comp = (pj_ice_strans_comp*) pj_stun_session_get_user_data(sess);
@@ -1103,4 +1105,5 @@
 static void stun_on_request_complete(pj_stun_session *sess,
 				     pj_status_t status,
+				     void *token,
 				     pj_stun_tx_data *tdata,
 				     const pj_stun_msg *response,
@@ -1116,6 +1119,8 @@
 
     comp = (pj_ice_strans_comp*) pj_stun_session_get_user_data(sess);
-    cand = (pj_ice_strans_cand*) tdata->user_data;
-
+    cand = (pj_ice_strans_cand*) token;
+
+    PJ_UNUSED_ARG(token);
+    PJ_UNUSED_ARG(tdata);
     PJ_UNUSED_ARG(src_addr);
     PJ_UNUSED_ARG(src_addr_len);
Index: pjproject/trunk/pjnath/src/pjnath/nat_detect.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/nat_detect.c	(revision 1912)
+++ pjproject/trunk/pjnath/src/pjnath/nat_detect.c	(revision 1913)
@@ -114,4 +114,5 @@
 static void on_request_complete(pj_stun_session *sess,
 			        pj_status_t status,
+				void *token,
 			        pj_stun_tx_data *tdata,
 			        const pj_stun_msg *response,
@@ -119,4 +120,5 @@
 				unsigned src_addr_len);
 static pj_status_t on_send_msg(pj_stun_session *sess,
+			       void *token,
 			       const void *pkt,
 			       pj_size_t pkt_size,
@@ -415,5 +417,6 @@
 	pj_stun_session_on_rx_pkt(sess->stun_sess, sess->rx_pkt, bytes_read,
 				  PJ_STUN_IS_DATAGRAM|PJ_STUN_CHECK_PACKET, 
-				  NULL, &sess->src_addr, sess->src_addr_len);
+				  NULL, NULL, 
+				  &sess->src_addr, sess->src_addr_len);
     }
 
@@ -439,4 +442,5 @@
  */
 static pj_status_t on_send_msg(pj_stun_session *stun_sess,
+			       void *token,
 			       const void *pkt,
 			       pj_size_t pkt_size,
@@ -447,4 +451,6 @@
     pj_ssize_t pkt_len;
     pj_status_t status;
+
+    PJ_UNUSED_ARG(token);
 
     sess = (nat_detect_session*) pj_stun_session_get_user_data(stun_sess);
@@ -463,4 +469,5 @@
 static void on_request_complete(pj_stun_session *stun_sess,
 			        pj_status_t status,
+				void *token,
 			        pj_stun_tx_data *tdata,
 			        const pj_stun_msg *response,
@@ -475,4 +482,5 @@
     unsigned test_id;
 
+    PJ_UNUSED_ARG(token);
     PJ_UNUSED_ARG(tdata);
     PJ_UNUSED_ARG(src_addr);
@@ -813,6 +821,6 @@
 
     /* Send the request */
-    status = pj_stun_session_send_msg(sess->stun_sess, PJ_TRUE, 
-				      sess->cur_server, 
+    status = pj_stun_session_send_msg(sess->stun_sess, NULL, PJ_TRUE,
+				      PJ_TRUE, sess->cur_server, 
 				      sizeof(pj_sockaddr_in),
 				      sess->result[test_id].tdata);
Index: pjproject/trunk/pjnath/src/pjnath/stun_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 1912)
+++ pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 1913)
@@ -350,5 +350,6 @@
 
 	/* Retry the request */
-	status = pj_stun_session_send_msg(sess, PJ_TRUE, src_addr, 
+	status = pj_stun_session_send_msg(sess, request->token, PJ_TRUE, 
+					  request->retransmit, src_addr, 
 					  src_addr_len, tdata);
 
@@ -378,7 +379,6 @@
 
     if (notify_user && sess->cb.on_request_complete) {
-	(*sess->cb.on_request_complete)(sess, status, tdata, 
-					response, 
-					src_addr, src_addr_len);
+	(*sess->cb.on_request_complete)(sess, status, tdata->token, tdata, 
+					response, src_addr, src_addr_len);
     }
 
@@ -398,6 +398,7 @@
     tdata = (pj_stun_tx_data*) pj_stun_client_tsx_get_data(tsx);
 
-    return tdata->sess->cb.on_send_msg(tdata->sess, stun_pkt, pkt_size,
-				       tdata->dst_addr, tdata->addr_len);
+    return tdata->sess->cb.on_send_msg(tdata->sess, tdata->token, stun_pkt, 
+				       pkt_size, tdata->dst_addr, 
+				       tdata->addr_len);
 }
 
@@ -731,5 +732,7 @@
 
 PJ_DEF(pj_status_t) pj_stun_session_send_msg( pj_stun_session *sess,
+					      void *token,
 					      pj_bool_t cache_res,
+					      pj_bool_t retransmit,
 					      const pj_sockaddr_t *server,
 					      unsigned addr_len,
@@ -743,4 +746,7 @@
     tdata->max_len = PJ_STUN_MAX_PKT_LEN;
     tdata->pkt = pj_pool_alloc(tdata->pool, tdata->max_len);
+
+    tdata->token = token;
+    tdata->retransmit = retransmit;
 
     /* Start locking the session now */
@@ -788,5 +794,5 @@
 
 	/* Send the request! */
-	status = pj_stun_client_tsx_send_msg(tdata->client_tsx, PJ_TRUE,
+	status = pj_stun_client_tsx_send_msg(tdata->client_tsx, retransmit,
 					     tdata->pkt, tdata->pkt_size);
 	if (status != PJ_SUCCESS && status != PJ_EPENDING) {
@@ -829,6 +835,6 @@
     
 	/* Otherwise for non-request message, send directly to transport. */
-	status = sess->cb.on_send_msg(sess, tdata->pkt, tdata->pkt_size,
-				      server, addr_len);
+	status = sess->cb.on_send_msg(sess, token, tdata->pkt, 
+				      tdata->pkt_size, server, addr_len);
 
 	if (status != PJ_SUCCESS && status != PJ_EPENDING) {
@@ -855,4 +861,5 @@
 					     unsigned code, 
 					     const char *errmsg,
+					     void *token,
 					     pj_bool_t cache, 
 					     const pj_sockaddr_t *dst_addr, 
@@ -869,5 +876,6 @@
 	return status;
 
-    return pj_stun_session_send_msg(sess, cache, dst_addr,  addr_len, tdata);
+    return pj_stun_session_send_msg(sess, token, cache, PJ_FALSE,
+				    dst_addr,  addr_len, tdata);
 }
 
@@ -888,6 +896,6 @@
 
     if (notify) {
-	(sess->cb.on_request_complete)(sess, notify_status, tdata, NULL,
-				       NULL, 0);
+	(sess->cb.on_request_complete)(sess, notify_status, tdata->token, 
+				       tdata, NULL, NULL, 0);
     }
 
@@ -921,5 +929,5 @@
 
 /* Send response */
-static pj_status_t send_response(pj_stun_session *sess, 
+static pj_status_t send_response(pj_stun_session *sess, void *token,
 				 pj_pool_t *pool, pj_stun_msg *response,
 				 const pj_stun_req_cred_info *auth_info,
@@ -954,5 +962,6 @@
 
     /* Send packet */
-    status = sess->cb.on_send_msg(sess, out_pkt, out_len, addr, addr_len);
+    status = sess->cb.on_send_msg(sess, token, out_pkt, out_len, 
+				  addr, addr_len);
 
     return status;
@@ -961,4 +970,5 @@
 /* Authenticate incoming message */
 static pj_status_t authenticate_req(pj_stun_session *sess,
+				    void *token,
 				    const pj_uint8_t *pkt,
 				    unsigned pkt_len,
@@ -982,6 +992,6 @@
     if (status != PJ_SUCCESS && response != NULL) {
 	PJ_LOG(5,(SNAME(sess), "Message authentication failed"));
-	send_response(sess, tmp_pool, response, &rdata->info, PJ_FALSE, 
-		      src_addr, src_addr_len);
+	send_response(sess, token, tmp_pool, response, &rdata->info, 
+		      PJ_FALSE, src_addr, src_addr_len);
     }
 
@@ -1071,6 +1081,6 @@
 		 "Request retransmission, sending cached response"));
 
-	send_response(sess, tmp_pool, t->msg, &t->auth_info, PJ_TRUE, 
-		      src_addr, src_addr_len);
+	send_response(sess, t->token, tmp_pool, t->msg, &t->auth_info, 
+		      PJ_TRUE, src_addr, src_addr_len);
 	return PJ_SUCCESS;
     }
@@ -1082,4 +1092,5 @@
 static pj_status_t on_incoming_request(pj_stun_session *sess,
 				       unsigned options,
+				       void *token,
 				       pj_pool_t *tmp_pool,
 				       const pj_uint8_t *in_pkt,
@@ -1103,6 +1114,7 @@
      */
     if ((options & PJ_STUN_NO_AUTHENTICATE) == 0) {
-	status = authenticate_req(sess, (const pj_uint8_t*) in_pkt, in_pkt_len,
-				  &rdata, tmp_pool, src_addr, src_addr_len);
+	status = authenticate_req(sess, token, (const pj_uint8_t*) in_pkt, 
+				  in_pkt_len,&rdata, tmp_pool, src_addr, 
+				  src_addr_len);
 	if (status != PJ_SUCCESS) {
 	    return status;
@@ -1113,5 +1125,5 @@
     if (sess->cb.on_rx_request) {
 	status = (*sess->cb.on_rx_request)(sess, in_pkt, in_pkt_len, &rdata,
-					   src_addr, src_addr_len);
+					   token, src_addr, src_addr_len);
     } else {
 	pj_str_t err_text;
@@ -1123,5 +1135,5 @@
 					     &err_text, &response);
 	if (status == PJ_SUCCESS && response) {
-	    status = send_response(sess, tmp_pool, response, 
+	    status = send_response(sess, token, tmp_pool, response, 
 				   NULL, PJ_FALSE, src_addr, src_addr_len);
 	}
@@ -1134,4 +1146,5 @@
 /* Handle incoming indication */
 static pj_status_t on_incoming_indication(pj_stun_session *sess,
+					  void *token,
 					  pj_pool_t *tmp_pool,
 					  const pj_uint8_t *in_pkt,
@@ -1146,5 +1159,5 @@
     if (sess->cb.on_rx_indication) {
 	return (*sess->cb.on_rx_indication)(sess, in_pkt, in_pkt_len, msg,
-					    src_addr, src_addr_len);
+					    token, src_addr, src_addr_len);
     } else {
 	return PJ_SUCCESS;
@@ -1157,4 +1170,5 @@
 					      pj_size_t pkt_size,
 					      unsigned options,
+					      void *token,
 					      unsigned *parsed_len,
 					      const pj_sockaddr_t *src_addr,
@@ -1181,5 +1195,5 @@
 	LOG_ERR_(sess, "STUN msg_decode() error", status);
 	if (response) {
-	    send_response(sess, tmp_pool, response, NULL,
+	    send_response(sess, token, tmp_pool, response, NULL,
 			  PJ_FALSE, src_addr, src_addr_len);
 	}
@@ -1218,5 +1232,5 @@
     } else if (PJ_STUN_IS_REQUEST(msg->hdr.type)) {
 
-	status = on_incoming_request(sess, options, tmp_pool, 
+	status = on_incoming_request(sess, options, token, tmp_pool, 
 				     (const pj_uint8_t*) packet, pkt_size, 
 				     msg, src_addr, src_addr_len);
@@ -1224,5 +1238,5 @@
     } else if (PJ_STUN_IS_INDICATION(msg->hdr.type)) {
 
-	status = on_incoming_indication(sess, tmp_pool, 
+	status = on_incoming_indication(sess, token, tmp_pool, 
 					(const pj_uint8_t*) packet, pkt_size,
 					msg, src_addr, src_addr_len);
